<?php

declare(strict_types=1);

namespace Dedi\SyliusVoucherPlugin\Twig;

use Dedi\SyliusVoucherPlugin\Doctrine\ORM\VoucherRepository;
use Sylius\Component\Core\Model\ShopUserInterface;
use Twig\Extension\AbstractExtension;
use Twig\TwigFunction;

class CheckUserVoucherEnabledExtension extends AbstractExtension
{
    private VoucherRepository $voucherRepository;

    public function __construct(VoucherRepository $voucherRepository)
    {
        $this->voucherRepository = $voucherRepository;
    }

    public function getFunctions(): array
    {
        return [
            new TwigFunction('dedi_voucher_check_user_enabled_voucher', [$this, 'isEnabled']),
        ];
    }

    public function isEnabled(ShopUserInterface $shopUser = null): array
    {
        if ($shopUser) {
            return $this->voucherRepository->findEnabledByUser($shopUser->getCustomer());
        }

        return [];
    }
}
